class Line(object):
    def __init__(self, v3Pos, v3Dir):
        self.pos = v3Pos
        self.dir = v3Dir
        
    def CalcPoint(self, par):
        return self.pos + (self.dir * par)
        
    def CalcPoint1(self):
        return self.pos + self.dir
        
    def CalcParClosestToPoint(self, v3Point):
        return (v3Point - self.pos).dot(self.dir)

    def CalcParsClosestToLine(self, other):
        A1 = self.pos
        A2 = self.CalcPoint1()
        B1 = other.pos
        B2 = other.CalcPoint1()
        
        return CalcClosestPointLineSegments(A1, A2, B1, B2)
        
# http://geomalgorithms.com/a07-_distance.html
def CalcClosestPointLineSegments(v3P0, v3P1, v3Q0, v3Q1):
    u = v3P1 - v3P0
    v = v3Q1 - v3Q0
    
    w0 = v3P0 - v3Q0
    a = u.dot(u)
    b = u.dot(v)
    c = v.dot(v)
    d = u.dot(w0)
    e = v.dot(w0)
    
    
    try: parP = (b * e - c * d) / (a * c - b * b)
    except: return None
    
    try: parQ = (a * e - b * d) / (a * c - b * b)
    except: return None
    
    
    return parP, parQ
        