import bpy
from bpy_extras import object_utils
        
def getActiveSelectedElement(bmesh):
    return bmesh.select_history.active
    
def getSelectedEdges(bmesh):
    rvl = []
    for edge in bmesh.edges:
        if edge.select: rvl.append(edge)
        
    return rvl
    
def getNormal(dir1, dir2):
    return dir1.cross(dir2).normalized()
    
def getBisection(dir1, dir2):
    rv = (dir1.normalized() + dir2.normalized()) * 0.5
    return rv.normalized()
    
def edgeContainsVertex(bmEdge, bmVert):
    return (bmVert in bmEdge.verts)
    
def addMesh(operator, context, name, verts, edges, faces):
    mesh = bpy.data.meshes.new(name)
    mesh.from_pydata(verts, edges, faces)
    mesh.update()
    
    newObj = object_utils.object_data_add(context, mesh, operator)
    newObj = newObj.object  # don't forget
    
    return newObj
